/* Experiment using macro capability of preprocessor to make a    */
/* menu description language for easier human reading of menus.   */
/* Finally found a use for those string and token pasting things! */

/* This will only work with the new ANSI compatible C preprocessor */
/* used by Turbo C++. The Turbo C 2.0 preprocessor did not include */
/* support for the token pasting function.                         */

/* Written by David Gwillim  23 June 1990 */
/* for the $2 Menu System package         */
/* Copyright (C) 1990 by David Gwillim    */

   /************************************************************************/

#define StartMenu(menu)          char *menu[] = {
#define Title(menutitle)         menutitle,
#define Entry(menuentry)         menuentry,
#define None                     ""
#define Cls                      "c"
#define ClsPause                 "p"
#define NoCls                    " "
#define DosCmd(action,cmdstr)    CommandCom,action"/C"cmdstr,
#define Exec(action,extprogram)  extprogram,action
#define Args(cmdstr)             cmdstr,
#define Link(menuname)           _##menuname,"",
#define EndMenu(menu)            ""};
#define StartMenuSystem          char **menu[] = {
#define Menu(menuid)             menuid,
#define EndMenuSystem            NULL};
#define NumberMenu(menu,num)     _##menu (char *) num
#define CommandCom               "C:\\COMMAND.COM"
#define Set(var,color,mono)      unsigned char var##[2]={color,mono};

   /************************************************************************/

Set(MenuTitleColor,0x1E,0x70)           /* color for the title        */
Set(MenuTitleLine,0,0)                  /* title pos (0=menu box top) */

Set(ScrnColor,0x71,0x07)                /* color of the screen        */
Set(ScrnChar,'\xB1',' ')                /* fill character for screen  */
Set(ScrnBoxColor,0x11,0x07)             /* color of box around screen */
Set(ScrnBoxStyle,4,0)                   /* box style for above        */

Set(MenuColor,0x4F,0x70)                /* color for menu entries     */
Set(MenuBoxColor,0x4E,0x70)             /* color for box around them  */
Set(MenuBoxStyle,1,1)                   /* box style for above        */

Set(MenuBorderTop,2,1)                  /* space above menu items     */
Set(MenuBorderBot,2,1)                  /* space below menu items     */
Set(MenuBorderLt,6,4)                   /* spaces to the left         */
Set(MenuBorderRt,6,4)                   /* spaces to the right        */

Set(LightBarColor,0x2F,0x07)            /* color for the light bar    */

   /************************************************************************/

#define _mainmenu  (char *) 0         /* can't define a macro with a   */
#define _submenu01 (char *) 1         /* macro unfortunately! And the  */
#define _submenu02 (char *) 2         /* Link value must be a literal. */

   /************************************************************************/

StartMenu(mainmenu)
   Title(" SAMPLE MENU ")
      Entry("XyWrite III Plus WP")
         DosCmd(Cls,"EDITOR")
      Entry("Turbo Power MAKEMENU")
         Exec(NoCls,"C:\\BIN\\MAKEMENU.EXE")
         Args(None)
      Entry("Paradox Database")
         DosCmd(NoCls,"PARADOX")
      Entry("QEDIT Editor")
          DosCmd(Cls,"Q")
      Entry("LIST File Browser")
          DosCmd(NoCls,"LIST")
      Entry("PMAP Memory Map Utility")
          Exec(ClsPause,"C:\\BIN\\PMAP.EXE")
          Args(None)
      Entry(">> SUB MENU TWO")
          Link(submenu02)
      Entry(">> SUB MENU THREE")
          Link(submenu02)
EndMenu(mainmenu)

StartMenu(submenu01)
   Title(" LEVEL TWO MENU ")
      Entry("Menu Entry One")
         DosCmd(ClsPause,"dir /w")
      Entry("Menu Entry Two")
         DosCmd(ClsPause,"dir")
      Entry(">> MAIN MENU")
         Link(mainmenu)
EndMenu(submenu01)

StartMenu(submenu02)
   Title(" LEVEL THREE MENU ")
      Entry("Menu Entry Three")
         DosCmd(ClsPause,"DIR /W")
      Entry("Menu Entry Four")
         DosCmd(ClsPause,"DIR /P")
      Entry(">> MAIN MENU")
         Link(mainmenu)
EndMenu(submenu02)

StartMenuSystem
   Menu(mainmenu)
   Menu(submenu01)
   Menu(submenu02)
EndMenuSystem

